#!/bin/bash

#verify run as root or sudo
if [[ $EUID -ne 0 ]]; then
   echo "This script must be run as root"
   exit 1
fi

readonly OFFSET_OPTIONS=3
declare -a TARGETS

show_ssh_hosts () {
	SSH_HOSTS_CONFIG_FILE="/root/.ssh/config"

	if [ -f $SSH_HOSTS_CONFIG_FILE ]; then
		TARGETS=($(cat $SSH_HOSTS_CONFIG_FILE | grep -E "^Host [^\*\*]" | sed "s/Host //"))
		# get length of an array
		length=${#TARGETS[@]}
		for (( j=0; j<length; j++ ));
		do
			#printf "Current index %d with value %s\n" $j "${TARGETS[$j]}"
			echo "$((j+$OFFSET_OPTIONS))) ${TARGETS[$j]}"
		done
	else
		echo "NOTE: Config hosts file not found"
	fi
}

is_root () {
	echo "test root"
	echo "$(id -u)"
    return $(id -u)
}

remote_update () {
	echo $1
ssh $1 << EOF
# date
# hostname
# cat /etc/resolv.conf
 $(typeset -f is_root)
 is_root
EOF
}

#for i in "${targets[@]}"
#do
#   :
   # do whatever on "$i" here
#   echo $i


echo "###################################"
echo "Auto Remote Updater"
echo -e "###################################\n"

finished=false
while [ "$finished" != "true" ]
do

# Choose script to install
echo "0) Sortir de l'script"
echo "1) current host: $(hostname)"
echo "2) custom host"
show_ssh_hosts
#echo -e "\n"

choosed=false
while [ "$choosed" != "true" ]
do
  read -p 'Indica quin host vols actualitzar (0 per sortir): ' HOST
  case $HOST in
     ("") echo "El número no pot ser buit";;
     (*[!0-9]*) echo "Has d'introduir un número";;
     (*) choosed=true #echo "just numeric";;
  esac
done

if [ "$HOST" = "0" ]; then
	finished=true
	exit 0
elif [ "$HOST" = "1" ]; then
	echo -e "update now!\n"
elif [ "$HOST" = "2" ]; then
	read -p 'Indica el host remot: ' CUSTOM
	echo $CUSTOM
elif [ "$((HOST-OFFSET_OPTIONS))" -gt 7 ]; then
	echo -e "Aquest número de host no existeix. Tornar a intentar-ho\n"
else
	index=$((HOST-OFFSET_OPTIONS))
	echo "${TARGETS[$index]}"
	remote_update "${TARGETS[$index]}"
fi

done
